#!/bin/bash

# json串
# "{\"dag_id\": \"csst-msc-l1-mbi\", \"parameters\": {\"dag_run_id\": \"202411111505581036\", \"message\": {\"obsid\": \"11009101682009\", \"chipid\": \"24\"}}}"
while true
do
    # obsid=$(redis-cli -h ${REDIS_SERVER} -p ${REDIS_PORT} rpop single-image-reduction:obsid)
    # msg=$(redis-cli -h ${REDIS_SERVER} -p ${REDIS_PORT} -a ${REDIS_PWD} rpop csst_data_list)
    msg=$(redis-cli -h 10.3.10.28 -a 123456 lpop csst_data_list_zxl)
    #redis-cli -h 10.3.10.28 -p 26379 -a "csst__2025" rpop csst_data_list
    echo "msg : "$msg

    if [ -z "$msg" ]; then
        echo "msg is empty"
        exit 102
    else
        echo "msg is not empty" $msg
        # 提取dag_id 模块名
        app_name=$(echo "$msg" | jq -r '.dag_id')
        echo "app_name : "$app_name

        # 提取dag_run_id 对应app_id
        dag_run_id=$(echo "$msg" | jq -r '.parameters.dag_run_id')
        echo "dag_run_id : "$dag_run_id
        #检索dag_run_id与app_id对应关系的配置文件appconfig.txt
        app_id=$(awk -v key="$dag_run_id" '$1 == key {print $2}' /config/appconfig.txt)
    
        # 检查是否找到app_id
        if [ -n "$app_id" ]; then
            echo "The appid for $dag_run_id is $app_id"
        else
            echo "$dag_run_id not found in appconfig.txt"
            exit 103
        fi

        # 提取obsid
        obsid=$(echo "$msg" | jq -r '.parameters.message.obsid')
        echo "obsid :"$obsid

        # 提取chipid
        chipid=$(echo "$msg" | jq -r '.parameters.message.chipid')
        echo "chipid :"$chipid

        message=$obsid"-"$chipid
        echo "message :"$message


        #send-message $obsid
        job_name="message-router-csst"
        scalebox task add --app-id ${app_id} --sink-job ${job_name} ${message}
        code=$?
        #code值不为0时，退出
        if [ $code -ne 0 ]; then
            exit $code
        fi
    fi
    echo $code
done